#!/bin/sh
name=$2
template=$1
start=$3

if [ -z "$name" -o -z "$template" ]
then
	echo Usage: $0 '<template name> <vm name> [nostart]'
	exit 1
fi

if [ "$start" = "nostart" ]
then
	start=""
else
	start="start"
fi

set -e

vmuuid=$(xe vm-install new-name-label=${name} template=${template})
if [ -z "$vmuuid" ]
then
	echo Error: Cannot determine vm id.
	exit 2
fi

vifuuid=$(xe vif-list vm-uuid="$vmuuid" | awk '/^uuid / { print $5 }')
if [ -z "$vifuuid" ]
then
	echo Error: Cannot determine network interface.
	exit 3
fi

mac=$(xe vif-param-get param-name=MAC uuid="$vifuuid")
if [ -z "$mac" ]
then
	echo Error: Cannot determine MAC address.
	exit 4
fi

# set memory sizes
# min=134217728
# max=1073741824
# xe vm-param-set uuid="$vmuuid" memory-static-min=$min memory-dynamic-min=$min memory-dynamic-max=$max memory-static-max=$max

if [ "$start" = "start" ]
then
	xe vm-start uuid=$vmuuid
fi

echo $mac
