package de.dassit.dassadmin;

import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import javax.naming.directory.SearchResult;

import de.dassit.ldap.Connection;
import de.dassit.ldap.Entry;
import de.dassit.ldap.EntryList;

public class DassContainer extends Entry {

	public DassContainer() {
		super();
	}

	public DassContainer(SearchResult sr) {
		super(sr);
	}

	@Override
	protected EntryList<? extends Entry> getEntryList() {
		return new EntryList<DassContainer>() {
			public void addInstance(SearchResult sr) {
				entries.add(new DassContainer(sr));
			}
		};
	}

	// @Override
	// public String getRDN() {
	// if(getFullName()==null || getFullName().equals("")) return container;
	// return super.getRDN();
	// }
	//
	@Override
	public void setContainer(String s) {
		super.setContainer(s);
		
		if(s==null) return;
		
		// special case if the object is the search base itself
		if (getFullName() != null && getFullName().equals("")) {
			// log.info("self-contained object detected");
			super.setContainer("");
			if (s.startsWith(namingAttribute + "=")) {
				String name = s.substring(namingAttribute.length() + 1);
				setName(name);
				setFullName(s);
			}
		}
	}

	@Override
	protected void setNamingParameters() {
		setNamingAttribute(defaultNamingAttribute);
		setObjectClasses(new String[] { "top", "organizationalUnit" });
		setContainer(defaultContainer);
	}

	public List<DassContainer> search(String filter, String container) {

		EntryList<DassContainer> entryList = new EntryList<DassContainer>() {
			public void addInstance(SearchResult sr) {
				entries.add(new DassContainer(sr));
			}
		};

		Connection.getDefaultConnection().search(filter, container, entryList);
		List<DassContainer> result = entryList.getEntries();

		Collections.sort(result, new Comparator<DassContainer>() {

			public int compare(DassContainer arg0, DassContainer arg1) {
				return arg0.getRDN().compareToIgnoreCase(arg1.getRDN());
			}
		});

		return entryList.getEntries();
	}

	public List<DassContainer> getContainers(String rdn) {
		return search("objectClass=organizationalUnit", rdn);
	}
}
