package de.dassit.dassadmin;

import java.util.ArrayList;
import java.util.List;

import javax.naming.directory.SearchResult;

import de.dassit.ldap.Entry;
import de.dassit.ldap.EntryList;

public class DassProfile extends Entry {

	public DassProfile() {
		super();
	}

	public DassProfile(SearchResult sr) {
		super(sr);
	}

	static String extraObjectClasses;
	
	@Override
	protected EntryList<? extends Entry> getEntryList() {
		return new EntryList<DassProfile>() {
			public void addInstance(SearchResult sr) {
				entries.add(new DassProfile(sr));
			}
		};
	}
	
	@Override
	protected void setNamingParameters() {
		setNamingAttribute(defaultNamingAttribute);
		setObjectClasses(new String[] { "top", "device","bootableDevice" });
		addObjectClassesCSV(extraObjectClasses);
		setContainer(defaultContainer);
	}
	
	public void setExtraObjectClasses(String csv) {
		extraObjectClasses=csv;
	}
	
	public List<? extends Entry> getAll() {
		return search("objectClass=device", defaultContainer);
	}
	
	public List<String> getAllNames() {
		List<? extends Entry> all = getAll();
		List<String> result= new ArrayList<String>(all.size());
		
		for(Entry e:all) {
			DassProfile n = (DassProfile) e;
			result.add(n.getName());
		}
		return result;
	}
}
