package de.dassit.dassadmin;

import java.util.Map;
import java.util.regex.Pattern;

public class ParamFilterTool {
	protected static Pattern invalidCharacters = null;

	public void setInvalidCharacters(String s) {
		invalidCharacters = Pattern.compile(s);
	}

	public String getInvalidCharacters() {
		return invalidCharacters.pattern();
	}

	public void validate(Map<String, Object> params) {
		if (invalidCharacters == null || params == null)
			return;

		for (Object v : params.values()) {
			String[] multiValue;
			if (v instanceof String) {
				multiValue = new String[] { (String) v };
			} else {
				multiValue = (String[]) v;
			}

			for (String m : multiValue) {
				if (invalidCharacters.matcher(m).matches())
					throw new IllegalArgumentException(
							"invalid characters in parameter");
			}
		}
	}
}
