package de.dassit.dassadmin;

import java.util.List;

import javax.naming.directory.SearchResult;

import de.dassit.ldap.Entry;
import de.dassit.ldap.EntryList;

public class Provider extends Entry {
	static String extraObjectClasses;

	public Provider() {
		super();
	}

	public Provider(SearchResult sr) {
		super(sr);
	}

	@Override
	protected EntryList<? extends Entry> getEntryList() {
		return new EntryList<Provider>() {
			public void addInstance(SearchResult sr) {
				entries.add(new Provider(sr));
			}
		};
	}

	@Override
	protected void setNamingParameters() {
		setNamingAttribute(defaultNamingAttribute);
		setObjectClasses(new String[] { "top", "person", "inetOrgPerson" });
		addObjectClassesCSV(extraObjectClasses);
		setContainer(defaultContainer);
	}

	public void setNetwork(Network n) {
		container = n.getRDN();
	}

	public Entry fetchByNetwork(String name, Network n) {
		final String filter = defaultNamingAttribute + "=" + name;

		List<? extends Entry> result = search(filter, n.getRDN());
		if (result.size() > 0)
			return result.get(0);
		else
			return null;
	}
}
